> ## Documentation Index
> Fetch the complete documentation index at: https://docs.apimart.ai/llms.txt
> Use this file to discover all available pages before exploring further.

# VEO3 비디오 생성

>  - 비동기 처리 모드, 후속 쿼리를 위해 작업 ID를 반환합니다
- 텍스트에서 비디오, 이미지에서 비디오 등 다양한 생성 모드를 지원합니다
- **4K** 해상도 출력 지원
- 생성된 비디오 링크는 24시간 유효합니다. 가능한 빨리 저장해 주세요 

<Info>
  **모델명 호환 안내**: 이 엔드포인트는 호환 별칭을 지원합니다. `veo3.1-fast-ext`는 `veo3.1-fast`, `veo3.1-quality-ext`는 `veo3.1-quality`, `veo3.1-lite-ext`는 `veo3.1-lite`와 각각 동일하므로 서로 바꿔 사용할 수 있고 효과도 동일합니다.
</Info>

<RequestExample>
  ```bash cURL theme={null}
  # model 에는 "veo3.1-fast" 를 입력할 수 있으며, 별칭 "veo3.1-fast-ext" 도 지원합니다
  curl --request POST \
    --url https://api.apimart.ai/v1/videos/generations \
    --header 'Authorization: Bearer <token>' \
    --header 'Content-Type: application/json' \
    --data '{
      "model": "veo3.1-fast",
      "prompt": "돌고래가 푸른 바다에서 뛰어다니는",
      "duration": 8,
      "aspect_ratio": "16:9",
      "image_urls": ["https://cdn.apimart.ai/doc/9998238783208208-9972597b-255d-4e7e-9649-e6ee38a837aa-image_task_01K88B53MTK41PP5KGDTG2PA5P_0.png"]
    }'
  ```

  ```python Python theme={null}
  import requests

  url = "https://api.apimart.ai/v1/videos/generations"

  payload = {
      "model": "veo3.1-fast",
      "prompt": "돌고래가 푸른 바다에서 뛰어다니는",
      "duration": 8,
      "aspect_ratio": "16:9",
      "image_urls": ["https://cdn.apimart.ai/doc/9998238783208208-9972597b-255d-4e7e-9649-e6ee38a837aa-image_task_01K88B53MTK41PP5KGDTG2PA5P_0.png"]
  }

  headers = {
      "Authorization": "Bearer <token>",
      "Content-Type": "application/json"
  }

  response = requests.post(url, json=payload, headers=headers)

  print(response.json())
  ```

  ```javascript JavaScript theme={null}
  const url = "https://api.apimart.ai/v1/videos/generations";

  const payload = {
    model: "veo3.1-fast",
    prompt: "돌고래가 푸른 바다에서 뛰어다니는",
    duration: 8,
    aspect_ratio: "16:9",
    image_urls: ["https://cdn.apimart.ai/doc/9998238783208208-9972597b-255d-4e7e-9649-e6ee38a837aa-image_task_01K88B53MTK41PP5KGDTG2PA5P_0.png"]
  };

  const headers = {
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
  };

  fetch(url, {
    method: "POST",
    headers: headers,
    body: JSON.stringify(payload)
  })
    .then(response => response.json())
    .then(data => console.log(data))
    .catch(error => console.error('Error:', error));
  ```

  ```go Go theme={null}
  package main

  import (
      "bytes"
      "encoding/json"
      "fmt"
      "io/ioutil"
      "net/http"
  )

  func main() {
      url := "https://api.apimart.ai/v1/videos/generations"

      payload := map[string]interface{}{
          "model":      "veo3.1-fast",
          "prompt":     "돌고래가 푸른 바다에서 뛰어다니는",
          "duration":   8,
          "aspect_ratio": "16:9",
          "image_urls":  ["https://cdn.apimart.ai/doc/9998238783208208-9972597b-255d-4e7e-9649-e6ee38a837aa-image_task_01K88B53MTK41PP5KGDTG2PA5P_0.png"],
      }

      jsonData, _ := json.Marshal(payload)

      req, _ := http.NewRequest("POST", url, bytes.NewBuffer(jsonData))
      req.Header.Set("Authorization", "Bearer <token>")
      req.Header.Set("Content-Type", "application/json")

      client := &http.Client{}
      resp, err := client.Do(req)
      if err != nil {
          panic(err)
      }
      defer resp.Body.Close()

      body, _ := ioutil.ReadAll(resp.Body)
      fmt.Println(string(body))
  }
  ```

  ```java Java theme={null}
  import java.net.http.HttpClient;
  import java.net.http.HttpRequest;
  import java.net.http.HttpResponse;
  import java.net.URI;

  public class Main {
      public static void main(String[] args) throws Exception {
          String url = "https://api.apimart.ai/v1/videos/generations";

          String payload = """
          {
            "model": "veo3.1-fast",
            "prompt": "돌고래가 푸른 바다에서 뛰어다니는",
            "duration": 8,
            "aspect_ratio": "16:9",
            "image_urls": ["https://cdn.apimart.ai/doc/9998238783208208-9972597b-255d-4e7e-9649-e6ee38a837aa-image_task_01K88B53MTK41PP5KGDTG2PA5P_0.png"]
          }
          """;

          HttpClient client = HttpClient.newHttpClient();
          HttpRequest request = HttpRequest.newBuilder()
              .uri(URI.create(url))
              .header("Authorization", "Bearer <token>")
              .header("Content-Type", "application/json")
              .POST(HttpRequest.BodyPublishers.ofString(payload))
              .build();

          HttpResponse<String> response = client.send(request,
              HttpResponse.BodyHandlers.ofString());

          System.out.println(response.body());
      }
  }
  ```

  ```php PHP theme={null}
  <?php

  $url = "https://api.apimart.ai/v1/videos/generations";

  $payload = [
      "model" => "veo3.1-fast",
      "prompt" => "돌고래가 푸른 바다에서 뛰어다니는",
      "duration" => 8,
      "aspect_ratio" => "16:9",
      "image_urls" => ["https://cdn.apimart.ai/doc/9998238783208208-9972597b-255d-4e7e-9649-e6ee38a837aa-image_task_01K88B53MTK41PP5KGDTG2PA5P_0.png"]
  ];

  $ch = curl_init($url);
  curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);
  curl_setopt($ch, CURLOPT_POST, true);
  curl_setopt($ch, CURLOPT_POSTFIELDS, json_encode($payload));
  curl_setopt($ch, CURLOPT_HTTPHEADER, [
      "Authorization: Bearer <token>",
      "Content-Type: application/json"
  ]);

  $response = curl_exec($ch);
  curl_close($ch);

  echo $response;
  ?>
  ```

  ```ruby Ruby theme={null}
  require 'net/http'
  require 'json'
  require 'uri'

  url = URI("https://api.apimart.ai/v1/videos/generations")

  payload = {
    model: "veo3.1-fast",
    prompt: "돌고래가 푸른 바다에서 뛰어다니는",
    duration: 8,
    aspect_ratio: "16:9",
    image_urls: ["https://cdn.apimart.ai/doc/9998238783208208-9972597b-255d-4e7e-9649-e6ee38a837aa-image_task_01K88B53MTK41PP5KGDTG2PA5P_0.png"]
  }

  http = Net::HTTP.new(url.host, url.port)
  http.use_ssl = true

  request = Net::HTTP::Post.new(url)
  request["Authorization"] = "Bearer <token>"
  request["Content-Type"] = "application/json"
  request.body = payload.to_json

  response = http.request(request)
  puts response.body
  ```

  ```swift Swift theme={null}
  import Foundation

  let url = URL(string: "https://api.apimart.ai/v1/videos/generations")!

  let payload: [String: Any] = [
      "model": "veo3.1-fast",
      "prompt": "돌고래가 푸른 바다에서 뛰어다니는",
      "duration": 8,
      "aspect_ratio": "16:9",
      "image_urls": ["https://cdn.apimart.ai/doc/9998238783208208-9972597b-255d-4e7e-9649-e6ee38a837aa-image_task_01K88B53MTK41PP5KGDTG2PA5P_0.png"]
  ]

  var request = URLRequest(url: url)
  request.httpMethod = "POST"
  request.setValue("Bearer <token>", forHTTPHeaderField: "Authorization")
  request.setValue("application/json", forHTTPHeaderField: "Content-Type")
  request.httpBody = try? JSONSerialization.data(withJSONObject: payload)

  let task = URLSession.shared.dataTask(with: request) { data, response, error in
      if let error = error {
          print("Error: \(error)")
          return
      }
      
      if let data = data, let responseString = String(data: data, encoding: .utf8) {
          print(responseString)
      }
  }

  task.resume()
  ```

  ```csharp C# theme={null}
  using System;
  using System.Net.Http;
  using System.Text;
  using System.Threading.Tasks;

  class Program
  {
      static async Task Main(string[] args)
      {
          var url = "https://api.apimart.ai/v1/videos/generations";

          var payload = @"{
              ""model"": ""veo3.1-fast"",
              ""prompt"": ""돌고래가 푸른 바다에서 뛰어다니는"",
              ""duration"": 8,
              ""aspect_ratio"": ""16:9"",
              ""image_urls"": [""https://cdn.apimart.ai/doc/9998238783208208-9972597b-255d-4e7e-9649-e6ee38a837aa-image_task_01K88B53MTK41PP5KGDTG2PA5P_0.png""]
          }";

          using var client = new HttpClient();
          client.DefaultRequestHeaders.Add("Authorization", "Bearer <token>");

          var content = new StringContent(payload, Encoding.UTF8, "application/json");
          var response = await client.PostAsync(url, content);
          var result = await response.Content.ReadAsStringAsync();

          Console.WriteLine(result);
      }
  }
  ```

  ```c C theme={null}
  #include <stdio.h>
  #include <curl/curl.h>

  int main(void) {
      CURL *curl;
      CURLcode res;

      curl_global_init(CURL_GLOBAL_DEFAULT);
      curl = curl_easy_init();

      if(curl) {
          const char *url = "https://api.apimart.ai/v1/videos/generations";
          const char *payload = "{"
              "\"model\":\"veo3.1-fast\","
              "\"prompt\":\"돌고래가 푸른 바다에서 뛰어다니는\","
              "\"duration\":8,"
              "\"aspect_ratio\":\"16:9\","
              "\"image_urls\":[\"https://cdn.apimart.ai/doc/9998238783208208-9972597b-255d-4e7e-9649-e6ee38a837aa-image_task_01K88B53MTK41PP5KGDTG2PA5P_0.png\"]"
          "}";

          struct curl_slist *headers = NULL;
          headers = curl_slist_append(headers, "Authorization: Bearer <token>");
          headers = curl_slist_append(headers, "Content-Type: application/json");

          curl_easy_setopt(curl, CURLOPT_URL, url);
          curl_easy_setopt(curl, CURLOPT_POSTFIELDS, payload);
          curl_easy_setopt(curl, CURLOPT_HTTPHEADER, headers);

          res = curl_easy_perform(curl);

          if(res != CURLE_OK) {
              fprintf(stderr, "curl_easy_perform() failed: %s\n",
                      curl_easy_strerror(res));
          }

          curl_slist_free_all(headers);
          curl_easy_cleanup(curl);
      }

      curl_global_cleanup();
      return 0;
  }
  ```

  ```objectivec Objective-C theme={null}
  #import <Foundation/Foundation.h>

  int main(int argc, const char * argv[]) {
      @autoreleasepool {
          NSURL *url = [NSURL URLWithString:@"https://api.apimart.ai/v1/videos/generations"];
          
          NSDictionary *payload = @{
              @"model": @"veo3.1-fast",
              @"prompt": @"돌고래가 푸른 바다에서 뛰어다니는",
              @"duration": @8,
              @"aspect_ratio": @"16:9",
              @"image_urls": @[@"https://cdn.apimart.ai/doc/9998238783208208-9972597b-255d-4e7e-9649-e6ee38a837aa-image_task_01K88B53MTK41PP5KGDTG2PA5P_0.png"]
          };
          
          NSError *error;
          NSData *jsonData = [NSJSONSerialization dataWithJSONObject:payload
                                                            options:0
                                                              error:&error];
          
          NSMutableURLRequest *request = [NSMutableURLRequest requestWithURL:url];
          [request setHTTPMethod:@"POST"];
          [request setValue:@"Bearer <token>" forHTTPHeaderField:@"Authorization"];
          [request setValue:@"application/json" forHTTPHeaderField:@"Content-Type"];
          [request setHTTPBody:jsonData];
          
          NSURLSessionDataTask *task = [[NSURLSession sharedSession] 
              dataTaskWithRequest:request
              completionHandler:^(NSData *data, NSURLResponse *response, NSError *error) {
                  if (error) {
                      NSLog(@"Error: %@", error);
                      return;
                  }
                  NSString *result = [[NSString alloc] initWithData:data 
                                                          encoding:NSUTF8StringEncoding];
                  NSLog(@"%@", result);
              }];
          
          [task resume];
          [[NSRunLoop mainRunLoop] run];
      }
      return 0;
  }
  ```

  ```ocaml OCaml theme={null}
  (* Requires cohttp and yojson libraries *)
  open Lwt
  open Cohttp
  open Cohttp_lwt_unix

  let url = "https://api.apimart.ai/v1/videos/generations"

  let payload = {|{
    "model": "veo3.1-fast",
    "prompt": "돌고래가 푸른 바다에서 뛰어다니는",
    "duration": 8,
    "aspect_ratio": "16:9",
    "image_urls": ["https://cdn.apimart.ai/doc/9998238783208208-9972597b-255d-4e7e-9649-e6ee38a837aa-image_task_01K88B53MTK41PP5KGDTG2PA5P_0.png"]
  }|}

  let () =
    let headers = Header.init ()
      |> fun h -> Header.add h "Authorization" "Bearer <token>"
      |> fun h -> Header.add h "Content-Type" "application/json"
    in
    let body = Cohttp_lwt.Body.of_string payload in
    
    let response = Client.post ~headers ~body (Uri.of_string url) >>= fun (resp, body) ->
      body |> Cohttp_lwt.Body.to_string >|= fun body_str ->
      print_endline body_str
    in
    Lwt_main.run response
  ```

  ```dart Dart theme={null}
  import 'dart:convert';
  import 'package:http/http.dart' as http;

  void main() async {
    final url = Uri.parse('https://api.apimart.ai/v1/videos/generations');
    
    final payload = {
      'model': 'veo3.1-fast',
      'prompt': '돌고래가 푸른 바다에서 뛰어다니는',
      'duration': 8,
      'aspect_ratio': '16:9',
      'image_urls': ['https://cdn.apimart.ai/doc/9998238783208208-9972597b-255d-4e7e-9649-e6ee38a837aa-image_task_01K88B53MTK41PP5KGDTG2PA5P_0.png']
    };
    
    final response = await http.post(
      url,
      headers: {
        'Authorization': 'Bearer <token>',
        'Content-Type': 'application/json',
      },
      body: jsonEncode(payload),
    );
    
    print(response.body);
  }
  ```

  ```r R theme={null}
  library(httr)
  library(jsonlite)

  url <- "https://api.apimart.ai/v1/videos/generations"

  payload <- list(
    model = "veo3.1-fast",
    prompt = "돌고래가 푸른 바다에서 뛰어다니는",
    duration = 8,
    aspect_ratio = "16:9",
    image_urls = c("https://cdn.apimart.ai/doc/9998238783208208-9972597b-255d-4e7e-9649-e6ee38a837aa-image_task_01K88B53MTK41PP5KGDTG2PA5P_0.png")
  )

  response <- POST(
    url,
    add_headers(
      Authorization = "Bearer <token>",
      `Content-Type` = "application/json"
    ),
    body = toJSON(payload, auto_unbox = TRUE),
    encode = "raw"
  )

  cat(content(response, "text"))
  ```
</RequestExample>

<ResponseExample>
  ```json 200 theme={null}
  {
    "code": 200,
    "data": [
      {
        "status": "submitted",
        "task_id": "task_01K8SGYNNNVBQTXNR4MM964S7K"
      }
    ]
  }
  ```

  ```json 400 theme={null}
  {
    "error": {
      "code": 400,
      "message": "요청 매개변수가 유효하지 않습니다",
      "type": "invalid_request_error"
    }
  }
  ```

  ```json 401 theme={null}
  {
    "error": {
      "code": 401,
      "message": "인증에 실패했습니다. API 키를 확인해 주세요",
      "type": "authentication_error"
    }
  }
  ```

  ```json 402 theme={null}
  {
    "error": {
      "code": 402,
      "message": "계정 잔액이 부족합니다. 충전 후 다시 시도해 주세요",
      "type": "payment_required"
    }
  }
  ```

  ```json 403 theme={null}
  {
    "error": {
      "code": 403,
      "message": "접근이 금지되었습니다. 이 리소스에 접근할 권한이 없습니다",
      "type": "permission_error"
    }
  }
  ```

  ```json 429 theme={null}
  {
    "error": {
      "code": 429,
      "message": "요청이 너무 빈번합니다. 잠시 후 다시 시도해 주세요",
      "type": "rate_limit_error"
    }
  }
  ```

  ```json 500 theme={null}
  {
    "error": {
      "code": 500,
      "message": "서버 내부 오류입니다. 잠시 후 다시 시도해 주세요",
      "type": "server_error"
    }
  }
  ```

  ```json 502 theme={null}
  {
    "error": {
      "code": 502,
      "message": "게이트웨이 오류입니다. 서버가 일시적으로 사용할 수 없습니다",
      "type": "bad_gateway"
    }
  }
  ```
</ResponseExample>

## 인증

<ParamField header="Authorization" type="string" required>
  모든 API 엔드포인트에서 Bearer Token 인증이 필요합니다

  API Key 획득:

  [API Key 관리 페이지](https://apimart.ai/keys)에 접속하여 API Key를 획득하세요

  사용 시 요청 헤더에 추가:

  ```
  Authorization: Bearer YOUR_API_KEY
  ```
</ParamField>

## 요청 파라미터

<ParamField body="model" type="string" default="veo3.1-fast" required>
  비디오 생성 모델명

  사용 가능한 모델：

  * `veo3.1-fast` - 빠른 생성 모델, 빠른 미리보기 및 반복 작업에 적합 (호환 별칭 `veo3.1-fast-ext`)
  * `veo3.1-quality` - 고품질 생성 모델, 최종 제작에 적합 (호환 별칭 `veo3.1-quality-ext`)
  * `veo3.1-lite` - 경량 생성 모델, 저비용 대량 생성에 적합 (호환 별칭 `veo3.1-lite-ext`)

  Example: `"veo3.1-fast"`

  <Note>
    구버전 호출과의 호환을 위해 별칭 `veo3.1-fast-ext`(`veo3.1-fast`에 해당), `veo3.1-quality-ext`(`veo3.1-quality`에 해당), `veo3.1-lite-ext`(`veo3.1-lite`에 해당)는 계속 정상적으로 사용할 수 있습니다.
  </Note>
</ParamField>

<ParamField body="prompt" type="string" required>
  비디오 생성 텍스트 설명
</ParamField>

<ParamField body="duration" type="integer">
  비디오 길이（초）

  고정값：`8`（VEO3은 8초 길이만 지원）
</ParamField>

<ParamField body="aspect_ratio" type="string">
  비디오 해상도

  지원 형식：

  * `16:9` (가로)
  * `9:16` (세로)
</ParamField>

<ParamField body="generation_type" type="string">
  비디오 생성 유형

  지원 유형:

  * `frame` - 프레임-투-비디오 (FL 모드)
  * `reference` - 참조 이미지-투-비디오

  미지정 시 이미지 수에 따라 자동 판단: 2장은 프레임-투-비디오, 3장은 참조 이미지-투-비디오

  **주의: `veo3.1-quality` 모델은 `reference` 모드를 지원하지 않습니다**

  <Warning>`veo3.1-lite` 모델은 이 파라미터를 지원하지 않습니다, 전달하지 마세요</Warning>
</ParamField>

<ParamField body="image_urls" type="array<url>">
  비디오 생성에 사용할 참조 이미지 URL 배열

  공개 접근 가능한 이미지 URL (http\:// 또는 https\://) 지원

  예시: `["https://example.com/image.jpg"]`

  **제한사항:**

  * 최대 3장
  * 프레임-투-비디오 모드의 경우: 첫 번째 이미지가 시작 프레임, 두 번째 이미지가 종료 프레임
  * 최대 파일 크기：10MB
  * 지원 형식：.jpeg、.jpg、.png、.webp

  <Warning>`veo3.1-lite` 모델은 이 파라미터를 지원하지 않습니다, 전달하지 마세요</Warning>
</ParamField>

<ParamField body="resolution" type="string">
  비디오 해상도

  지원되는 값:

  * `720p` (기본값)
  * `1080p`
  * `4k`
</ParamField>

<ParamField body="enable_gif" type="boolean">
  GIF 출력 형식을 활성화합니다. 기본값: false

  주의: GIF와 1080p, 4k 해상도는 동시에 사용할 수 없습니다
</ParamField>

<ParamField body="official_fallback" type="boolean" default="false">
  공식 채널을 폴백으로 사용할지 여부

  * `false`: 사용하지 않음 (기본값)
  * `true`: 공식 채널 사용

  <Warning>`veo3.1-lite` 모델은 이 파라미터를 지원하지 않습니다, 전달하지 마세요</Warning>
</ParamField>

## 응답

<ResponseField name="code" type="integer">
  응답 상태 코드
</ResponseField>

<ResponseField name="data" type="array">
  응답 데이터 배열

  <Expandable title="속성">
    <ResponseField name="status" type="string">
      작업 상태

      * `submitted` - 제출됨
    </ResponseField>

    <ResponseField name="task_id" type="string">
      고유한 작업 식별자
    </ResponseField>
  </Expandable>
</ResponseField>
